/*---------------------------------------------------------------//
 RAWR - Preview Box (Terayon Edition)	v0.4

  2007, RAWR - Template Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
 (CC) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: that.stevens.guy@gmail.com, r.tuininga@quicknet.nl
	Forum: <official forum post>
 	Homepage: <official hompage>
//---------------------------------------------------------------*/

//--Pre-set some variables.----------------------//
var image	=new Image();
var boxOpen	=null;
var disable	=false;
var volume	=50;
var playmethod	="single";
var aspect	=426 // 426 = 16:9 // 320 = 4:3
    
//--The main initialiser.------------------------//
function initPreviewBox(target,type,content,width,height) {
	if(disable==false) {
		disable=true;
		setTimeout("disable=false;",350);
		if(target!=boxOpen) {
			if(boxOpen!=null)		boxFade(boxOpen, "out");
			if(type=="Image")		spawnImageBox(target,content);
			else if(type=="MP3")		spawnFlashBox(target,content,width);
			else if(type=="DivX")		spawnDivxBox(target,content);
			else if(type=="SWF")		spawnSWFBox(target,content);
		} else {
			boxFade(boxOpen,"out");
		}
	}
}

//--Spawn a 'Loading' box.-----------------------//
function spawnBox(target,width,height) {
	gEBI(target).innerHTML = "<div class='Box' style='width:"+(width+10)+"px;filter:alpha(opacity=0);opacity:0;' id=\""+target+"Box\"><div style=\"width:"+(width+2)+"px;\" class=daBox1><span class=ModuleTitle id=\""+target+"Name\"><i>Loading...</i></span><a href=\"javascript:void(0);\" onClick=\"boxFade('"+target+"', 'out');\" style=\"cursor:normal;float:right;\"><div class=clo></div></a><div class=mov style=\"cursor:move;float:right;margin-right:5px;\"></div></div><div style=\"width:"+width+"px; height:"+height+"px;\" class=daBox2 id=\""+target+"Content\"><img src=\"/template/images/spacer.gif\" style=\"visibility:hidden;width:0px;height:20px;\"/><br /><img src=\"/template/images/loading.gif\" /></div><div style=\"width:"+(width+10)+"px;\" class=daBox3>&nbsp;</div></div>";
	Box = gEBI(target+"Box");
	Box.style.left = Box.offsetLeft-530+(480-Box.offsetWidth)+"px";
	Box.style.top = Box.offsetTop-(Box.offsetHeight+18)/2+"px";
	boxFade(target,"in");
	document.onmousedown = startDrag;
}

//--Spawn an SWF box.----------------------------//
function spawnSWFBox(target,content,name) {
	spawnBox(target,413,300);
	setTimeout("setSWFBox(\""+target+"\",\""+content+"\",\""+name+"\");",300);
}
function setSWFBox(target,content,name) {
	setName(name=="undefined"?content:name);
	content = "<object width=413 height=300 type='application/x-shockwave-flash' data=\"http://"+infoHost+infoFolder+escape(content)+"\"><param name=movie value=\""+escape(content)+"\"/></object>";
	gEBI(target+"Content").innerHTML = content
}

//--Spawn a DivX box.----------------------------//
function spawnDivxBox(target,content,name) {
	spawnBox(target,aspect,240);
	setTimeout("setDivxBox(\""+target+"\",\""+content+"\",\""+name+"\");",300);
}
function setDivxBox(target, content, name) {
	setName(name=="undefined"?content:name);
	content = "<object classid=\"clsid:67DABFBF-D0AB-41fa-9C46-CC0F21721616\" width=\""+aspect+"\" height=\"240\" codebase=\"http://go.divx.com/plugin/DivXBrowserPlugin.cab\"><param name=\"src\" value=\"http://"+infoHost+infoFolder+escape(content)+"\"><embed type=\"video/divx\" src=\"http://"+infoHost+infoFolder+escape(content)+"\" width=\""+aspect+"\" height=\"240\" pluginspage=\"http://go.divx.com/plugin/download/\"></embed></object>"
	gEBI(target+"Content").innerHTML = content
}

//--Spawn an MP3 box.----------------------------//
function spawnFlashBox(target,content,name) {
	spawnBox(target,320,50);
	setTimeout("setFlashBox(\""+target+"\",\""+content+"\",\""+name+"\");",300);
}
function setFlashBox(target,content,name) {
	setName(name=="undefined"?content:name);
	volume=(getCookie('Volume'))?getCookie('Volume'):volume;
	if(name!="undefined") {
		playmethod="single";
	} else if(getCookie('Method')) {
		playmethod=getCookie('Method')+"&mode=full"; 
	} else {
		playmethod="single&mode=full";
	}
	content = "<embed allowscriptaccess=always src='/template/flash/RAWR-Player.swf' width=320 height=50 type='application/x-shockwave-flash' flashvars=\"colorset=terayon&volume="+volume+"&playmethod="+playmethod+"&autostart=true&file="+escape(content)+"\"/>";
	gEBI(target+"Content").innerHTML = content;
}

//--Spawn an Image box.--------------------------//
function spawnImageBox(target,content) {
	image =new Image();
	image.src= infoFolder+"previews_and_thumbnails/prev-"+content+".jpg";
	if(image.complete) {
		spawnBox(target,image.width,image.height);
		setImageBox(target,content,"setImmediatly");
	} else {
		setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"none\");",10);
	}
}
function setImageBox(target,content,status) {
	if(image.width!=0) {
		if(status == "none") {
			spawnBox(target,image.width,image.height);
			status = "boxLoaded";
		}
		if(status == "boxLoaded") {
			setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"setImage\");",325);
		} else if(status == "setImage") {
			if(image.complete) {
				gEBI(target+"Content").innerHTML = "<img src=\""+image.src+"\" alt=\"\" style=\"filter:alpha(opacity=0);opacity:0\" id=\""+target+"ImageBox\">";
				boxFade(target,"image");
				gEBI(target+"Name").innerHTML = unescape(content);
				image = null;
			} else {
				setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"setImage\");",200);
			}
		} else if(status == "setImmediatly") {
			gEBI(target+"Content").innerHTML = "<img src=\""+image.src+"\" alt=\"\">";
			setName(content);
			image = null;
		}
	} else {
		setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"none\");",50);
	}
}

//--Crops the name if necessary.-----------------//
function setName(fileName) {
	var crop = false;
	var name = unescape(fileName.substring(fileName.lastIndexOf("/")?fileName.lastIndexOf("/")+1:0, fileName.lastIndexOf(".")));
	var extension = fileName.substring(fileName.toLowerCase().lastIndexOf("."),fileName.length);
	gEBI(boxOpen+"Name","inn",name+extension);
	while (gEBI(boxOpen+"Box").offsetWidth - 50 < gEBI(boxOpen + "Name").offsetWidth) {
		crop =true;
		name =name.substring(0,name.length-4)+".. ";
		gEBI(boxOpen+"Name","inn",name+extension);
	}
	if(crop==true&&name.substring(name.length-3,name.length-4)==" ") {
		name =name.substring(0,name.length-4)+".. ";
		gEBI(boxOpen+"Name","inn",name+extension);
	}
}

//--The fade function.---------------------------//
function boxFade(target,method,alpha) {
	method=="image"?id=gEBI(target+"ImageBox"):id=gEBI(target+"Box");
	if(!alpha) {
		if(method=="in"||method=="image") {
			if(method=="in") boxOpen = target;
			for(Y=24;Y>0;Y--) setTimeout("boxFade(\""+target+"\",\""+method+"\",\""+Y*4+"\");",Y*12);
			setTimeout("gEBI(\""+id.id+"\").style.opacity = 0.99;",300);
			setTimeout("gEBI(\""+id.id+"\").style.filter = 'alpha(opacity=100)';",300);
		} else if(method == "out") {
			if(gEBI(target+"Content").innerHTML.substr(1,3)!='img')	gEBI(target+"Content").innerHTML='';
			id.name = "fadingOut";
			if(boxOpen == target) boxOpen = null;
			for(Q=24;Q>0;Q--) setTimeout("boxFade(\""+target+"\",\"out\","+(100+(Q*-4))+");", Q*12);
			setTimeout("gEBI(\""+target+"\").innerHTML = '';",300);
		}
	} else {
		try {
			if(((method=="in"||method=="image")&&id.name!="fadingOut")||method=="out") {	
				id.style.filter	="alpha(opacity="+alpha+")";
				id.style.opacity =(alpha/100);
			}
		} catch(e) {}
	}
}

//--The drag function.---------------------------//
var sObj=null;
var drgOK=false;
var dX=dY=pX=pY=0;
function drag(e) {
	if(e==null)e=window.event;
	if(e.button<=1&&drgOK) {
		sObj.style.left=e.clientX-dX+(document.documentElement.scrollLeft-pX)+'px';
		sObj.style.top=e.clientY-dY+(document.documentElement.scrollTop-pY)+'px';
		return false;
	}
}
function endDrag(e) {
	gEBI(boxOpen).style.cursor = 'default';
	document.onmousemove = document.onmouseup = null;
	drgOK = false;
}
function startDrag(e) {
	if(e==null)e=window.event;
	var t=e.target!=null?e.target:e.srcElement;
	try {
		if(t.parentNode.className=="Box"||t.parentNode.parentNode.className=="Box"||t.parentNode.parentNode.parentNode.className=="Box") {
			sObj =t.parentNode.parentNode.parentNode.className=="Box"?t.parentNode.parentNode.parentNode:t.parentNode.parentNode.className=="Box"?t.parentNode.parentNode:t.parentNode;
			drgOK=true;
			dX =e.clientX-parseInt(sObj.style.left);
			dY =e.clientY-parseInt(sObj.style.top);
			pX = document.documentElement.scrollLeft;
			pY = document.documentElement.scrollTop;
			gEBI(boxOpen).style.cursor = 'move';
			document.onmousemove = drag;
			document.onmouseup = endDrag;
			return false;
		}
	} catch(e) {}
}

//--RAWR-Player flash interface.-----------------//
function playerVolume(volume) {
	setCookie('Volume',volume,exp);
}
function playbackMethod(playmethod) {
	setCookie('Method',playmethod,exp);
}